if (starslalomlamps_init) then return end -- Check if the script has already been run

freeslot(
	"MT_SECRETSLIDELAMP",
	"MT_SECRETSLIDELAMP_SIDE", "S_SECRETSLIDELAMP_SIDE",
	"MT_SECRETSLIDELAMP_BOTTOM", "S_SECRETSLIDELAMP_BOTTOM",
	"MT_SECRETSLIDELAMP_HANDLE", "S_SECRETSLIDELAMP_HANDLE",
	"MT_SECRETSLIDELAMP_LIGHT", "S_SECRETSLIDELAMP_LIGHT",
	"SPR_SSLP"
)

mobjinfo[MT_SECRETSLIDELAMP] = {
	doomednum = 1964,
	spawnstate = S_INVISIBLE,
	radius = 6*FRACUNIT,
	height = 1*FRACUNIT,
	flags = MF_SCENERY|MF_NOBLOCKMAP|MF_NOGRAVITY
}

mobjinfo[MT_SECRETSLIDELAMP_SIDE] = {
	doomednum = -1,
	spawnstate = S_SECRETSLIDELAMP_SIDE,
	radius = 3*FRACUNIT,
	height = 1*FRACUNIT,
	flags = MF_SCENERY|MF_NOBLOCKMAP|MF_NOGRAVITY
}

states[S_SECRETSLIDELAMP_SIDE] = {
	sprite = SPR_SSLP,
	frame = A|FF_PAPERSPRITE,
	tics = -1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_SECRETSLIDELAMP_SIDE
}

mobjinfo[MT_SECRETSLIDELAMP_BOTTOM] = {
	doomednum = -1,
	spawnstate = S_SECRETSLIDELAMP_BOTTOM,
	radius = 3*FRACUNIT,
	height = 1*FRACUNIT,
	flags = MF_SCENERY|MF_NOBLOCKMAP|MF_NOGRAVITY
}

states[S_SECRETSLIDELAMP_BOTTOM] = {
	sprite = SPR_SSLP,
	frame = C|FF_FLOORSPRITE,
	tics = -1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_SECRETSLIDELAMP_BOTTOM
}

mobjinfo[MT_SECRETSLIDELAMP_HANDLE] = {
	doomednum = -1,
	spawnstate = S_SECRETSLIDELAMP_HANDLE,
	radius = 3*FRACUNIT,
	height = 1*FRACUNIT,
	flags = MF_SCENERY|MF_NOBLOCKMAP|MF_NOGRAVITY
}

states[S_SECRETSLIDELAMP_HANDLE] = {
	sprite = SPR_SSLP,
	frame = B|FF_PAPERSPRITE,
	tics = -1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_SECRETSLIDELAMP_HANDLE
}

mobjinfo[MT_SECRETSLIDELAMP_LIGHT] = {
	doomednum = -1,
	spawnstate = S_SECRETSLIDELAMP_LIGHT,
	radius = 3*FRACUNIT,
	height = 1*FRACUNIT,
	flags = MF_SCENERY|MF_NOBLOCKMAP|MF_NOGRAVITY
}

states[S_SECRETSLIDELAMP_LIGHT] = {
	sprite = SPR_SSLP,
	frame = D|FF_PAPERSPRITE,
	tics = -1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_SECRETSLIDELAMP_LIGHT
}

-- Spawn func
local forwardOffset, lateralOffset, topOffset, forwardAngle, lateralAngle, leftAngle, rightAngle, mobX, mobY, mobZ
local function SpawnPaperspriteObj(mobj)
	-- Set local variables since we're accessing them a lot
	forwardOffset = 16*mapobjectscale
	lateralOffset = 16*mapobjectscale
	topOffset = 64*mapobjectscale
	forwardAngle = mobj.angle + ANGLE_90
	lateralAngle = mobj.angle + ANGLE_180
	leftAngle = mobj.angle + ANGLE_135
	rightAngle = mobj.angle + ANGLE_225
	mobX, mobY, mobZ = mobj.x, mobj.y, mobj.z
	
	-- Spawn sides
	mobj.sides = {
		front = P_SpawnMobj(
			mobX + FixedMul(forwardOffset, sin(leftAngle)),
			mobY - FixedMul(forwardOffset, cos(leftAngle)),
			mobZ, MT_SECRETSLIDELAMP_SIDE),
		back = P_SpawnMobj(
			mobX + FixedMul(forwardOffset, sin(rightAngle)),
		 	mobY - FixedMul(forwardOffset, cos(rightAngle)),
		 	mobZ, MT_SECRETSLIDELAMP_SIDE),
		left = P_SpawnMobj(
			mobX - FixedMul(lateralOffset, sin(leftAngle)),
			mobY + FixedMul(lateralOffset, cos(leftAngle)),
			mobZ, MT_SECRETSLIDELAMP_SIDE),
		right = P_SpawnMobj(
			mobX - FixedMul(lateralOffset, sin(rightAngle)),
			mobY + FixedMul(lateralOffset, cos(rightAngle)),
			mobZ, MT_SECRETSLIDELAMP_SIDE),
		handle = P_SpawnMobj(
			mobX,
			mobY,
			mobZ, MT_SECRETSLIDELAMP_HANDLE),
		light = P_SpawnMobj(
			mobX + FixedMul(56*mapobjectscale, cos(lateralAngle)),
			mobY + FixedMul(56*mapobjectscale, sin(lateralAngle)),
			mobZ, MT_SECRETSLIDELAMP_LIGHT),
		top = P_SpawnMobj(mobX - FixedMul(4*mapobjectscale, cos(leftAngle)), mobY - FixedMul(4*mapobjectscale, sin(leftAngle)), mobZ + 4*mapobjectscale + topOffset, MT_SECRETSLIDELAMP_BOTTOM),
		bot = P_SpawnMobj(mobX - FixedMul(4*mapobjectscale, cos(leftAngle)), mobY - FixedMul(4*mapobjectscale, sin(leftAngle)), mobZ + 4*mapobjectscale, MT_SECRETSLIDELAMP_BOTTOM)
	}
	
	-- Whyyy is this not an FF_ constant
	mobj.sides.front.renderflags = RF_FULLBRIGHT
	mobj.sides.back.renderflags = RF_FULLBRIGHT
	mobj.sides.left.renderflags = RF_FULLBRIGHT
	mobj.sides.right.renderflags = RF_FULLBRIGHT
	mobj.sides.light.renderflags = RF_ADD
	mobj.sides.top.renderflags = RF_NOSPLATBILLBOARD
	mobj.sides.bot.renderflags = RF_NOSPLATBILLBOARD
	
	-- Angle sides
	mobj.sides.front.angle, mobj.sides.left.angle, mobj.sides.top.angle, mobj.sides.bot.angle = leftAngle, leftAngle, leftAngle, leftAngle
	mobj.sides.back.angle, mobj.sides.right.angle = rightAngle, rightAngle
	mobj.sides.light.angle = forwardAngle
	mobj.sides.handle.angle = lateralAngle

end -- Close function

addHook("MapThingSpawn", SpawnPaperspriteObj, MT_SECRETSLIDELAMP)

rawset(_G, "starslalomlamps_init", true) -- The script ran, don't run it again